package com.example.smartledz_wifi_test.plugin;


import android.net.wifi.WifiConfiguration;

import androidx.annotation.NonNull;


import com.example.smartledz_wifi_test.MainActivity;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodChannel;

public class WifiPlugin implements FlutterPlugin {

    // 插件名称
    public static final String channelName = "com.vanstone.WifiPlugin";

    private static final int PERMISSIONS_REQUEST_CODE = 101;


    @Override
    public void onAttachedToEngine(@NonNull FlutterPlugin.FlutterPluginBinding binding) {
        //可以利用binding对象获取到Android中需要的Context对象
//        Context applicationContext = binding.getApplicationContext();


        //设置channel名称，之后flutter中也要一样
        MethodChannel channel = new MethodChannel(binding.getFlutterEngine().getDartExecutor(), channelName);

        //把当前的MethodCallHandler设置
        channel.setMethodCallHandler((call, result) -> {
            String method = call.method;
            switch (method) {
                case "startScan":
                    startScan();
//                    System.out.println("-------------------");
//                    System.out.println(scanResults);
//                    System.out.println("-------------------");
                    break;
                case "connect":
                    String ssid = call.argument("ssid");
                    String bssid = call.argument("bssid");
                    String password = call.argument("password");
                    connect(ssid, bssid, password);
//                    result.success(connect(mac));
                    break;
            }
        });
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {

    }


    private void startScan() {
        MainActivity.wifiManager.startScan(); // 触发Wi-Fi扫描
    }

    // 连接wifi
    private void connect(String ssid, String bssid, String pwd) {
        WifiConfiguration wifiConfig = new WifiConfiguration();
        wifiConfig.SSID = "\"" + ssid + "\"";
        wifiConfig.BSSID = bssid;
        wifiConfig.preSharedKey = "\"" + pwd + "\"";
        int networkId = MainActivity.wifiManager.addNetwork(wifiConfig);
        MainActivity.wifiManager.disconnect();
        MainActivity.wifiManager.enableNetwork(networkId, true);
        MainActivity.wifiManager.reconnect();
    }

}
